#ifndef VECTOR_H
#define VECTOR_H

#include <iostream>
#include <vector>

class Vector {
private:
    std::vector<double> data;

public:
    // Constructor
    Vector(size_t size);

    // Default constructor
    Vector();

    // Destructor
    ~Vector();

    // Copy Constructor
    Vector(const Vector& other);

    // Move constructor
    Vector(Vector&& other) noexcept;

    Vector(std::initializer_list<double> init);

    // Assignment Operator
    Vector& operator=(const Vector& other);

    // Overload + operator
    Vector operator+(const Vector& other);

    // Overload << operator
    friend std::ostream& operator<<(std::ostream& os, const Vector& vec);
};

#endif // VECTOR_H
