#include <iostream>
#include "vector.h"
using namespace std;

// Constructor
Vector::Vector(size_t size) : data(size) {}

Vector::Vector() {
    cout << "Default constructor called" << endl;
}

// Destructor   (   delete this   )  ( this = &obj  )
Vector::~Vector() {
    cout << "Destructor called" << endl;
}

// Copy Constructor (  Obj obj2(obj1)  )
Vector::Vector(const Vector& other) : data(other.data) {
    cout << "Copy Constructor called" << endl;
}

// Move constructor
Vector::Vector(Vector&& other) noexcept : data(other.data) {
    cout << "Move Constructor called" << endl;
    other.data.clear();
}

// Allows the use of initializer lists {} for object construction
Vector::Vector(std::initializer_list<double> init) : data(init) {
    cout << "Initializer list constructor called" << endl;
}

// Assignment Operator  (  obj2 = obj1 )
Vector& Vector::operator=(const Vector& other) {
    cout << "Assignment operator called" << endl;
    if (this != &other) {
        data = other.data;
    }
    return *this;
}

// Overload + operator  (   obj = *this + other  )
Vector Vector::operator+(const Vector& other) {
    cout << "Addition operator called" << endl;
    Vector result(data.size());
    for (size_t i = 0; i < data.size(); ++i) {
        result.data[i] = data[i] + other.data[i];
    }
    return result;
}

// Overload << operator
std::ostream& operator<<(std::ostream& os, const Vector& vec) {
    cout << "operator<< called" << endl;
    for (const auto& val : vec.data) {
        os << val << " ";
    }
    return os;
}
